/************************************************************************************
*                                                                                   *
*   File Name   : output_handler.c                                                       *
*   Contents    : XXXXXXX                    *
*   Version     : 1.1                                                               *
*************************************************************************************/ 
#include "sfr_r813.h" 
#include "output_handler.h"

//init after reset
void f_vd_adcInit(void)
{
	adcon1 = 0x28; //10bit-mode
}

void f_vd_AcquireVoltages(void)
{
static unsigned int ui_voltageAcquisitionState;

switch (ui_voltageAcquisitionState)
{
	//undefined
	case d_undefinedHandlerState:
	    ui_voltageAcquisitionState = d_startAN0;
		break;
	//start acquisition on AN0
	case d_startAN0:
	    ui_voltageAcquisitionState = d_waitAN0;
		adcon0 = 0x80;  //select CH0
		adst = 1;       //start conversion
		break;
	//check acquisition ready on AN0
	case d_waitAN0:
	    if (adst == 0)
		{
		    ui_voltageAcquisitionState = d_startAN1;
			UI_CHARGER_VOLTAGE_AD = ad;
        }
		break;
	//start acquisition on AN1
	case d_startAN1:
	    ui_voltageAcquisitionState = d_waitAN1;
		adcon0 = 0x81;  //select CH1
		adst = 1;       //start conversion
		break;
	case d_waitAN1:
	    if (adst == 0)
		{
		    ui_voltageAcquisitionState = d_startAN0;
			UI_BATTERY_VOLTAGE_AD = ad;
        }
		break;
} //switch
}
