/************************************************************************************
*                                                                                   *
*   File Name   : output_handler.h                                                  *
*   Contents    : XXXXXX                                                            *
*   Version     : 1.3                                                               *
*************************************************************************************/ 
#define cSwitchDebounceTimeMs 10
#define c2ConsecutiveSwitchPressesMs 1100

#define d_undefinedHandlerState 0
#define d_Disp1_SegA            1
#define d_Disp1_SegB            2
#define d_Disp1_SegC            3
#define d_Disp1_SegD            4
#define d_Disp1_SegE            5
#define d_Disp1_SegF            6
#define d_Disp1_SegG            7

#define d_Disp2_SegA            8
#define d_Disp2_SegB            9
#define d_Disp2_SegC           10
#define d_Disp2_SegD           11
#define d_Disp2_SegE           12
#define d_Disp2_SegF           13
#define d_Disp2_SegG           14

#define d_Disp3_SegA           15
#define d_Disp3_SegB           16
#define d_Disp3_SegC           17
#define d_Disp3_SegD           18
#define d_Disp3_SegE           19
#define d_Disp3_SegF           20
#define d_Disp3_SegG           21

#define d_Disp4_SegA           22
#define d_Disp4_SegB           23
#define d_Disp4_SegC           24
#define d_Disp4_SegD           25
#define d_Disp4_SegE           26
#define d_Disp4_SegF           27
#define d_Disp4_SegG           28

#define d_bitmask_segA      0x01															 
#define d_bitmask_segB      0x02
#define d_bitmask_segC      0x04
#define d_bitmask_segD      0x08
#define d_bitmask_segE      0x10
#define d_bitmask_segF      0x20
#define d_bitmask_segG      0x40

#define d_value_mask_disp1  0x000000FF			 															 															 															 
#define d_value_mask_disp2  0x0000FF00
#define d_value_mask_disp3  0x00FF0000
#define d_value_mask_disp4  0xFF000000

#define D1_port             p1_2
#define D2_port				p1_1
#define D3_port				p1_6
#define D4_port				p1_3
#define SegA_port			p0_1
#define SegB_port			p0_2
#define SegC_port			p0_3
#define SegD_port			p0_4
#define SegE_port			p0_5
#define SegF_port			p3_0
#define SegG_port			p3_3
#define ActLED_port         p1_0

#define Set_D1              (D1_port = 1)
#define Reset_D1            (D1_port = 0)
#define Set_D2              (D2_port = 1)
#define Reset_D2            (D2_port = 0)
#define Set_D3              (D3_port = 1)
#define Reset_D3            (D3_port = 0)
#define Set_D4              (D4_port = 1)
#define Reset_D4            (D4_port = 0)

#define Set_SegA            (SegA_port = 1)
#define Reset_SegA          (SegA_port = 0) 
#define Set_SegB            (SegB_port = 1)
#define Reset_SegB          (SegB_port = 0) 
#define Set_SegC            (SegC_port = 1)
#define Reset_SegC          (SegC_port = 0) 
#define Set_SegD            (SegD_port = 1)
#define Reset_SegD          (SegD_port = 0) 
#define Set_SegE            (SegE_port = 1)
#define Reset_SegE          (SegE_port = 0) 
#define Set_SegF            (SegF_port = 1)
#define Reset_SegF          (SegF_port = 0) 
#define Set_SegG            (SegG_port = 1)
#define Reset_SegG          (SegG_port = 0) 

#define Set_D1_SegA         {Set_D1; Reset_D2; Reset_D3; Reset_D4; Set_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D1_SegB         {Set_D1; Reset_D2; Reset_D3; Reset_D4; Reset_SegA; Set_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D1_SegC         {Set_D1; Reset_D2; Reset_D3; Reset_D4; Reset_SegA; Reset_SegB; Set_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D1_SegD         {Set_D1; Reset_D2; Reset_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Set_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D1_SegE         {Set_D1; Reset_D2; Reset_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Set_SegE; Reset_SegF; Reset_SegG;}
#define Set_D1_SegF         {Set_D1; Reset_D2; Reset_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Set_SegF; Reset_SegG;}
#define Set_D1_SegG         {Set_D1; Reset_D2; Reset_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Set_SegG;}
#define Reset_D1_AllSegs    {Set_D1; Reset_D2; Reset_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}

#define Set_D2_SegA         {Reset_D1; Set_D2; Reset_D3; Reset_D4; Set_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D2_SegB         {Reset_D1; Set_D2; Reset_D3; Reset_D4; Reset_SegA; Set_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D2_SegC         {Reset_D1; Set_D2; Reset_D3; Reset_D4; Reset_SegA; Reset_SegB; Set_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D2_SegD         {Reset_D1; Set_D2; Reset_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Set_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D2_SegE         {Reset_D1; Set_D2; Reset_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Set_SegE; Reset_SegF; Reset_SegG;}
#define Set_D2_SegF         {Reset_D1; Set_D2; Reset_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Set_SegF; Reset_SegG;}
#define Set_D2_SegG         {Reset_D1; Set_D2; Reset_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Set_SegG;}
#define Reset_D2_AllSegs    {Reset_D1; Set_D2; Reset_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}

#define Set_D3_SegA         {Reset_D1; Reset_D2; Set_D3; Reset_D4; Set_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D3_SegB         {Reset_D1; Reset_D2; Set_D3; Reset_D4; Reset_SegA; Set_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D3_SegC         {Reset_D1; Reset_D2; Set_D3; Reset_D4; Reset_SegA; Reset_SegB; Set_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D3_SegD         {Reset_D1; Reset_D2; Set_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Set_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D3_SegE         {Reset_D1; Reset_D2; Set_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Set_SegE; Reset_SegF; Reset_SegG;}
#define Set_D3_SegF         {Reset_D1; Reset_D2; Set_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Set_SegF; Reset_SegG;}
#define Set_D3_SegG         {Reset_D1; Reset_D2; Set_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Set_SegG;}
#define Reset_D3_AllSegs    {Reset_D1; Reset_D2; Set_D3; Reset_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}

#define Set_D4_SegA         {Reset_D1; Reset_D2; Reset_D3; Set_D4; Set_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D4_SegB         {Reset_D1; Reset_D2; Reset_D3; Set_D4; Reset_SegA; Set_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D4_SegC         {Reset_D1; Reset_D2; Reset_D3; Set_D4; Reset_SegA; Reset_SegB; Set_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D4_SegD         {Reset_D1; Reset_D2; Reset_D3; Set_D4; Reset_SegA; Reset_SegB; Reset_SegC; Set_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}
#define Set_D4_SegE         {Reset_D1; Reset_D2; Reset_D3; Set_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Set_SegE; Reset_SegF; Reset_SegG;}
#define Set_D4_SegF         {Reset_D1; Reset_D2; Reset_D3; Set_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Set_SegF; Reset_SegG;}
#define Set_D4_SegG         {Reset_D1; Reset_D2; Reset_D3; Set_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Set_SegG;}
#define Reset_D4_AllSegs    {Reset_D1; Reset_D2; Reset_D3; Set_D4; Reset_SegA; Reset_SegB; Reset_SegC; Reset_SegD; Reset_SegE; Reset_SegF; Reset_SegG;}

//analogue_inputs.c
#define d_startAN0 1
#define d_waitAN0  2
#define d_startAN1 3
#define d_waitAN1  4

extern unsigned int UI_CHARGER_VOLTAGE_AD;
extern unsigned int UI_BATTERY_VOLTAGE_AD;

void f_vd_controllerInit(void);
void f_vd_outputHandler(unsigned long content_to_display);
void f_vd_TIMERX_init(void);
void f_vd_EXTINTS_init(void);
void f_vd_UART0_init(void);
void f_vd_adcInit(void);
void f_vd_AcquireVoltages(void);
